/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __BOOK_CODER_H
#define __BOOK_CODER_H

#include "mptk.h"

class book_coder {

public:
	unsigned int numSlots;
	unsigned int numSamples;
	unsigned int sampleRate;
	unsigned int numBlocks;
	dictionary *dict;
	MP_Book_c **bookA;
	unsigned int firstSlotPos;
	unsigned int slotLen;
	unsigned int firstNonZeroSlot;
	unsigned int lastNonZeroSlot;
	slot *s;
	bitplane *bp;
	MP_Signal_c *signal;
	bool is_psy;

	book_coder( MP_Book_c *book, unsigned int set_numSamples, unsigned int mode );
	~book_coder( void );

	void init_mdct( void );
	void init_signal( void );
	void init_bitplane( void );

	unsigned int write_header( FILE *output );

	void load_slot( unsigned int idx_slot );
	void interleave_slot( void );
	unsigned int code_slot( unsigned int bitrate );
	void synth_coded_slot( unsigned int idx_slot );
	unsigned int write_slot( FILE *output );
	void synth_slot( unsigned int idx_slot );
};

#endif
