/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __BOOK_DECODER_H
#define __BOOK_DECODER_H

#include "mptk.h"

class book_decoder {

public:
	unsigned int numSlots;
	unsigned int bitrate;
	unsigned int numSamples;
	unsigned int sampleRate;
	MP_Book_c *book;
	dictionary *dict;
	unsigned int numBlocks;
	unsigned int firstSlotPos;
	unsigned int slotLen;
	unsigned int firstNonZeroSlot;
	unsigned int lastNonZeroSlot;
	bitplane *bp;
	MP_Signal_c *signal;
	bool is_psy;
	bool is_wav;
	bool is_book;

public:
	book_decoder( unsigned int mode );
	~book_decoder( void );
	unsigned int read_header( FILE *input );
	unsigned int read_slot( FILE *input, unsigned int bitrate, unsigned int maxNumBytes );
	void decode_slot( unsigned int idxSlot, unsigned int numBytes );
	void init_decoder( void );
};

#endif
