/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __PSY_H
#define __PSY_H

class psy {

public:
	unsigned int len;
	unsigned int input_len;
	unsigned int sampleRate;
	double part_width;
	unsigned int nb_part;
	double sfm_db_max;
	double tmn;
	double nmt;
	double tb;
	double *snr;
	double *bc;
	double *freq_hz;
	double *freq_bark;
	unsigned int *low;
	unsigned int *high;
	unsigned int *nb_bins;
	unsigned int *part;
	double *median_hz;
	double *median_bark;
	double *ath_db;
	double *ath_lin;
	double *rnorm;
	double *input;
	double *r;
	double *e;
	double *ecb;
	double *nb;
	double *smr;
	double *mdct_e;

public:
	psy( unsigned int set_len, unsigned int set_sampleRate );
	~psy( void );
	int compute( mdct *m, double *signal, double *mask );
	double sprdngf( double b, double bb );
	double hz2bark( double f );
	double ath( double f );
};

#endif
