/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __SLOT_H
#define __SLOT_H

class slot {

public:
	dictionary *dict;
	unsigned int numBlocks;
	double ***data;
	unsigned int ***inter;
	unsigned int *numFrames;
	int *frameShift;
	unsigned int *numFreqs;
	double *dataI;
	unsigned int dataI_len;
	unsigned int signal_len;
	double *signal;
	psy **psy_blocks;
	mdct **mdct_blocks;

public:
	slot(unsigned int set_numBlocks, dictionary *set_dict);
	slot(unsigned int set_numBlocks, dictionary *set_dict, unsigned int sampleRate);
	~slot( void );
	void init_mdct( void );
	void init_psy( unsigned int sampleRate );
	void load_atoms( MP_Book_c *book, unsigned int slotPos );
	void save_atoms( MP_Book_c *book, unsigned int slotPos );
	void synthesize( void );
	void reset_data( void );
	void interleave_data( void );
	void deinterleave_data( void );
	void compute_mask( slot *mask );
	void init_interleaving( void );
};

#endif
